//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PSms_h
#define PSms_h

#include "mozilla/Attributes.h"
#include "base/basictypes.h"
#include "prtime.h"
#include "nscore.h"
#include "IPCMessageStart.h"
#include "IPC/IPCMessageUtils.h"
#include "nsAutoPtr.h"
#include "nsStringGlue.h"
#include "nsTArray.h"
#include "nsIFile.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "mozilla/dom/sms/Types.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct SmsMessageData|
//
namespace mozilla {
namespace dom {
namespace sms {
class SmsMessageData MOZ_FINAL
{
private:

public:
    SmsMessageData();

    SmsMessageData(
            const PRInt32& _id,
            const DeliveryState& _delivery,
            const nsString& _sender,
            const nsString& _receiver,
            const nsString& _body,
            const PRUint64& _timestamp)
    {
        Init();
        Assign(_id, _delivery, _sender, _receiver, _body, _timestamp);
    }

    SmsMessageData(const SmsMessageData& _o)
    {
        Init();
        Assign((_o).id(), (_o).delivery(), (_o).sender(), (_o).receiver(), (_o).body(), (_o).timestamp());
    }

    ~SmsMessageData();

    void
    operator=(const SmsMessageData& _o)
    {
        Assign((_o).id(), (_o).delivery(), (_o).sender(), (_o).receiver(), (_o).body(), (_o).timestamp());
    }

    bool
    operator==(const SmsMessageData& _o) const;

    PRInt32&
    id()
    {
        return id_;
    }
    const PRInt32&
    id() const
    {
        return id_;
    }

    DeliveryState&
    delivery()
    {
        return delivery_;
    }
    const DeliveryState&
    delivery() const
    {
        return delivery_;
    }

    nsString&
    sender()
    {
        return sender_;
    }
    const nsString&
    sender() const
    {
        return sender_;
    }

    nsString&
    receiver()
    {
        return receiver_;
    }
    const nsString&
    receiver() const
    {
        return receiver_;
    }

    nsString&
    body()
    {
        return body_;
    }
    const nsString&
    body() const
    {
        return body_;
    }

    PRUint64&
    timestamp()
    {
        return timestamp_;
    }
    const PRUint64&
    timestamp() const
    {
        return timestamp_;
    }

private:
    void
    Init();

    void
    Assign(
            const PRInt32& _id,
            const DeliveryState& _delivery,
            const nsString& _sender,
            const nsString& _receiver,
            const nsString& _body,
            const PRUint64& _timestamp);

    PRInt32 id_;
    DeliveryState delivery_;
    nsString sender_;
    nsString receiver_;
    nsString body_;
    PRUint64 timestamp_;
};
} // namespace sms
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct SmsFilterData|
//
namespace mozilla {
namespace dom {
namespace sms {
class SmsFilterData MOZ_FINAL
{
private:

public:
    SmsFilterData();

    SmsFilterData(
            const PRUint64& _startDate,
            const PRUint64& _endDate,
            const InfallibleTArray<nsString>& _numbers,
            const DeliveryState& _delivery)
    {
        Init();
        Assign(_startDate, _endDate, _numbers, _delivery);
    }

    SmsFilterData(const SmsFilterData& _o)
    {
        Init();
        Assign((_o).startDate(), (_o).endDate(), (_o).numbers(), (_o).delivery());
    }

    ~SmsFilterData();

    void
    operator=(const SmsFilterData& _o)
    {
        Assign((_o).startDate(), (_o).endDate(), (_o).numbers(), (_o).delivery());
    }

    bool
    operator==(const SmsFilterData& _o) const;

    PRUint64&
    startDate()
    {
        return startDate_;
    }
    const PRUint64&
    startDate() const
    {
        return startDate_;
    }

    PRUint64&
    endDate()
    {
        return endDate_;
    }
    const PRUint64&
    endDate() const
    {
        return endDate_;
    }

    InfallibleTArray<nsString>&
    numbers()
    {
        return numbers_;
    }
    const InfallibleTArray<nsString>&
    numbers() const
    {
        return numbers_;
    }

    DeliveryState&
    delivery()
    {
        return delivery_;
    }
    const DeliveryState&
    delivery() const
    {
        return delivery_;
    }

private:
    void
    Init();

    void
    Assign(
            const PRUint64& _startDate,
            const PRUint64& _endDate,
            const InfallibleTArray<nsString>& _numbers,
            const DeliveryState& _delivery);

    PRUint64 startDate_;
    PRUint64 endDate_;
    InfallibleTArray<nsString> numbers_;
    DeliveryState delivery_;
};
} // namespace sms
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Code common to PSmsChild and PSmsParent
//
namespace mozilla {
namespace dom {
namespace sms {
namespace PSms {

enum State {
    __Dead,
    __Null,
    __Error,
    __Start = __Null
};

enum MessageType {
    PSmsStart = PSmsMsgStart << 16,
    PSmsPreStart = (PSmsMsgStart << 16) - 1,
    Msg_NotifyReceivedMessage__ID,
    Msg_NotifySentMessage__ID,
    Msg_NotifyDeliveredMessage__ID,
    Msg_NotifyRequestSmsSent__ID,
    Msg_NotifyRequestSmsSendFailed__ID,
    Msg_NotifyRequestGotSms__ID,
    Msg_NotifyRequestGetSmsFailed__ID,
    Msg_NotifyRequestSmsDeleted__ID,
    Msg_NotifyRequestSmsDeleteFailed__ID,
    Msg_NotifyRequestNoMessageInList__ID,
    Msg_NotifyRequestCreateMessageList__ID,
    Msg_NotifyRequestGotNextMessage__ID,
    Msg_NotifyRequestReadListFailed__ID,
    Msg_HasSupport__ID,
    Reply_HasSupport__ID,
    Msg_GetNumberOfMessagesForText__ID,
    Reply_GetNumberOfMessagesForText__ID,
    Msg_SendMessage__ID,
    Msg_SaveReceivedMessage__ID,
    Reply_SaveReceivedMessage__ID,
    Msg_SaveSentMessage__ID,
    Reply_SaveSentMessage__ID,
    Msg_GetMessage__ID,
    Msg_DeleteMessage__ID,
    Msg_CreateMessageList__ID,
    Msg_GetNextMessageInList__ID,
    Msg_ClearMessageList__ID,
    Msg___delete____ID,
    Reply___delete____ID,
    PSmsEnd
};

bool
Transition(
        State from,
        mozilla::ipc::Trigger trigger,
        State* next);

class Msg_NotifyReceivedMessage :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::dom::sms::SmsMessageData SmsMessageData;
    typedef mozilla::dom::sms::SmsFilterData SmsFilterData;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Msg_NotifyReceivedMessage__ID
    };
    Msg_NotifyReceivedMessage() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PSms::Msg_NotifyReceivedMessage")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_NotifyReceivedMessage(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_NotifySentMessage :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::dom::sms::SmsMessageData SmsMessageData;
    typedef mozilla::dom::sms::SmsFilterData SmsFilterData;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Msg_NotifySentMessage__ID
    };
    Msg_NotifySentMessage() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PSms::Msg_NotifySentMessage")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_NotifySentMessage(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_NotifyDeliveredMessage :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::dom::sms::SmsMessageData SmsMessageData;
    typedef mozilla::dom::sms::SmsFilterData SmsFilterData;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Msg_NotifyDeliveredMessage__ID
    };
    Msg_NotifyDeliveredMessage() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PSms::Msg_NotifyDeliveredMessage")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_NotifyDeliveredMessage(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_NotifyRequestSmsSent :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::dom::sms::SmsMessageData SmsMessageData;
    typedef mozilla::dom::sms::SmsFilterData SmsFilterData;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Msg_NotifyRequestSmsSent__ID
    };
    Msg_NotifyRequestSmsSent() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PSms::Msg_NotifyRequestSmsSent")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_NotifyRequestSmsSent(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_NotifyRequestSmsSendFailed :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::dom::sms::SmsMessageData SmsMessageData;
    typedef mozilla::dom::sms::SmsFilterData SmsFilterData;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Msg_NotifyRequestSmsSendFailed__ID
    };
    Msg_NotifyRequestSmsSendFailed() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PSms::Msg_NotifyRequestSmsSendFailed")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_NotifyRequestSmsSendFailed(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_NotifyRequestGotSms :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::dom::sms::SmsMessageData SmsMessageData;
    typedef mozilla::dom::sms::SmsFilterData SmsFilterData;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Msg_NotifyRequestGotSms__ID
    };
    Msg_NotifyRequestGotSms() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PSms::Msg_NotifyRequestGotSms")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_NotifyRequestGotSms(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_NotifyRequestGetSmsFailed :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::dom::sms::SmsMessageData SmsMessageData;
    typedef mozilla::dom::sms::SmsFilterData SmsFilterData;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Msg_NotifyRequestGetSmsFailed__ID
    };
    Msg_NotifyRequestGetSmsFailed() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PSms::Msg_NotifyRequestGetSmsFailed")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_NotifyRequestGetSmsFailed(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_NotifyRequestSmsDeleted :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::dom::sms::SmsMessageData SmsMessageData;
    typedef mozilla::dom::sms::SmsFilterData SmsFilterData;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Msg_NotifyRequestSmsDeleted__ID
    };
    Msg_NotifyRequestSmsDeleted() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PSms::Msg_NotifyRequestSmsDeleted")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_NotifyRequestSmsDeleted(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_NotifyRequestSmsDeleteFailed :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::dom::sms::SmsMessageData SmsMessageData;
    typedef mozilla::dom::sms::SmsFilterData SmsFilterData;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Msg_NotifyRequestSmsDeleteFailed__ID
    };
    Msg_NotifyRequestSmsDeleteFailed() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PSms::Msg_NotifyRequestSmsDeleteFailed")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_NotifyRequestSmsDeleteFailed(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_NotifyRequestNoMessageInList :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::dom::sms::SmsMessageData SmsMessageData;
    typedef mozilla::dom::sms::SmsFilterData SmsFilterData;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Msg_NotifyRequestNoMessageInList__ID
    };
    Msg_NotifyRequestNoMessageInList() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PSms::Msg_NotifyRequestNoMessageInList")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_NotifyRequestNoMessageInList(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_NotifyRequestCreateMessageList :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::dom::sms::SmsMessageData SmsMessageData;
    typedef mozilla::dom::sms::SmsFilterData SmsFilterData;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Msg_NotifyRequestCreateMessageList__ID
    };
    Msg_NotifyRequestCreateMessageList() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PSms::Msg_NotifyRequestCreateMessageList")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_NotifyRequestCreateMessageList(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_NotifyRequestGotNextMessage :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::dom::sms::SmsMessageData SmsMessageData;
    typedef mozilla::dom::sms::SmsFilterData SmsFilterData;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Msg_NotifyRequestGotNextMessage__ID
    };
    Msg_NotifyRequestGotNextMessage() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PSms::Msg_NotifyRequestGotNextMessage")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_NotifyRequestGotNextMessage(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_NotifyRequestReadListFailed :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::dom::sms::SmsMessageData SmsMessageData;
    typedef mozilla::dom::sms::SmsFilterData SmsFilterData;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Msg_NotifyRequestReadListFailed__ID
    };
    Msg_NotifyRequestReadListFailed() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PSms::Msg_NotifyRequestReadListFailed")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_NotifyRequestReadListFailed(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_HasSupport :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::dom::sms::SmsMessageData SmsMessageData;
    typedef mozilla::dom::sms::SmsFilterData SmsFilterData;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Msg_HasSupport__ID
    };
    Msg_HasSupport() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PSms::Msg_HasSupport")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_HasSupport(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_HasSupport :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::dom::sms::SmsMessageData SmsMessageData;
    typedef mozilla::dom::sms::SmsFilterData SmsFilterData;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Reply_HasSupport__ID
    };
    Reply_HasSupport() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PSms::Reply_HasSupport")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_HasSupport(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_GetNumberOfMessagesForText :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::dom::sms::SmsMessageData SmsMessageData;
    typedef mozilla::dom::sms::SmsFilterData SmsFilterData;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Msg_GetNumberOfMessagesForText__ID
    };
    Msg_GetNumberOfMessagesForText() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PSms::Msg_GetNumberOfMessagesForText")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_GetNumberOfMessagesForText(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_GetNumberOfMessagesForText :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::dom::sms::SmsMessageData SmsMessageData;
    typedef mozilla::dom::sms::SmsFilterData SmsFilterData;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Reply_GetNumberOfMessagesForText__ID
    };
    Reply_GetNumberOfMessagesForText() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PSms::Reply_GetNumberOfMessagesForText")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_GetNumberOfMessagesForText(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_SendMessage :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::dom::sms::SmsMessageData SmsMessageData;
    typedef mozilla::dom::sms::SmsFilterData SmsFilterData;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Msg_SendMessage__ID
    };
    Msg_SendMessage() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PSms::Msg_SendMessage")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_SendMessage(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_SaveReceivedMessage :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::dom::sms::SmsMessageData SmsMessageData;
    typedef mozilla::dom::sms::SmsFilterData SmsFilterData;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Msg_SaveReceivedMessage__ID
    };
    Msg_SaveReceivedMessage() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PSms::Msg_SaveReceivedMessage")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_SaveReceivedMessage(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_SaveReceivedMessage :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::dom::sms::SmsMessageData SmsMessageData;
    typedef mozilla::dom::sms::SmsFilterData SmsFilterData;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Reply_SaveReceivedMessage__ID
    };
    Reply_SaveReceivedMessage() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PSms::Reply_SaveReceivedMessage")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_SaveReceivedMessage(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_SaveSentMessage :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::dom::sms::SmsMessageData SmsMessageData;
    typedef mozilla::dom::sms::SmsFilterData SmsFilterData;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Msg_SaveSentMessage__ID
    };
    Msg_SaveSentMessage() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PSms::Msg_SaveSentMessage")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_SaveSentMessage(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_SaveSentMessage :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::dom::sms::SmsMessageData SmsMessageData;
    typedef mozilla::dom::sms::SmsFilterData SmsFilterData;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Reply_SaveSentMessage__ID
    };
    Reply_SaveSentMessage() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PSms::Reply_SaveSentMessage")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_SaveSentMessage(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_GetMessage :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::dom::sms::SmsMessageData SmsMessageData;
    typedef mozilla::dom::sms::SmsFilterData SmsFilterData;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Msg_GetMessage__ID
    };
    Msg_GetMessage() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PSms::Msg_GetMessage")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_GetMessage(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_DeleteMessage :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::dom::sms::SmsMessageData SmsMessageData;
    typedef mozilla::dom::sms::SmsFilterData SmsFilterData;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Msg_DeleteMessage__ID
    };
    Msg_DeleteMessage() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PSms::Msg_DeleteMessage")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_DeleteMessage(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_CreateMessageList :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::dom::sms::SmsMessageData SmsMessageData;
    typedef mozilla::dom::sms::SmsFilterData SmsFilterData;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Msg_CreateMessageList__ID
    };
    Msg_CreateMessageList() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PSms::Msg_CreateMessageList")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_CreateMessageList(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_GetNextMessageInList :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::dom::sms::SmsMessageData SmsMessageData;
    typedef mozilla::dom::sms::SmsFilterData SmsFilterData;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Msg_GetNextMessageInList__ID
    };
    Msg_GetNextMessageInList() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PSms::Msg_GetNextMessageInList")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_GetNextMessageInList(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_ClearMessageList :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::dom::sms::SmsMessageData SmsMessageData;
    typedef mozilla::dom::sms::SmsFilterData SmsFilterData;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Msg_ClearMessageList__ID
    };
    Msg_ClearMessageList() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PSms::Msg_ClearMessageList")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_ClearMessageList(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg___delete__ :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::dom::sms::SmsMessageData SmsMessageData;
    typedef mozilla::dom::sms::SmsFilterData SmsFilterData;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Msg___delete____ID
    };
    Msg___delete__() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PSms::Msg___delete__")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg___delete__(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply___delete__ :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::dom::sms::SmsMessageData SmsMessageData;
    typedef mozilla::dom::sms::SmsFilterData SmsFilterData;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Reply___delete____ID
    };
    Reply___delete__() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PSms::Reply___delete__")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply___delete__(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};



} // namespace PSms
} // namespace sms
} // namespace dom
} // namespace mozilla

#endif // ifndef PSms_h
