//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PHal_h
#define PHal_h

#include "mozilla/Attributes.h"
#include "base/basictypes.h"
#include "prtime.h"
#include "nscore.h"
#include "IPCMessageStart.h"
#include "IPC/IPCMessageUtils.h"
#include "nsAutoPtr.h"
#include "nsStringGlue.h"
#include "nsTArray.h"
#include "nsIFile.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nspr4/prtime.h"
#include "mozilla/HalSensor.h"
#include "mozilla/HalTypes.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct BatteryInformation|
//
namespace mozilla {
namespace hal {
class BatteryInformation MOZ_FINAL
{
private:

public:
    BatteryInformation();

    BatteryInformation(
            const double& _level,
            const bool& _charging,
            const double& _remainingTime)
    {
        Init();
        Assign(_level, _charging, _remainingTime);
    }

    BatteryInformation(const BatteryInformation& _o)
    {
        Init();
        Assign((_o).level(), (_o).charging(), (_o).remainingTime());
    }

    ~BatteryInformation();

    void
    operator=(const BatteryInformation& _o)
    {
        Assign((_o).level(), (_o).charging(), (_o).remainingTime());
    }

    bool
    operator==(const BatteryInformation& _o) const;

    double&
    level()
    {
        return level_;
    }
    const double&
    level() const
    {
        return level_;
    }

    bool&
    charging()
    {
        return charging_;
    }
    const bool&
    charging() const
    {
        return charging_;
    }

    double&
    remainingTime()
    {
        return remainingTime_;
    }
    const double&
    remainingTime() const
    {
        return remainingTime_;
    }

private:
    void
    Init();

    void
    Assign(
            const double& _level,
            const bool& _charging,
            const double& _remainingTime);

    double level_;
    bool charging_;
    double remainingTime_;
};
} // namespace hal
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct LightConfiguration|
//
namespace mozilla {
namespace hal {
class LightConfiguration MOZ_FINAL
{
private:
    typedef mozilla::hal::LightType LightType;
    typedef mozilla::hal::LightMode LightMode;
    typedef mozilla::hal::FlashMode FlashMode;

public:
    LightConfiguration();

    LightConfiguration(
            const LightType& _light,
            const LightMode& _mode,
            const FlashMode& _flash,
            const uint32_t& _flashOnMS,
            const uint32_t& _flashOffMS,
            const uint32_t& _color)
    {
        Init();
        Assign(_light, _mode, _flash, _flashOnMS, _flashOffMS, _color);
    }

    LightConfiguration(const LightConfiguration& _o)
    {
        Init();
        Assign((_o).light(), (_o).mode(), (_o).flash(), (_o).flashOnMS(), (_o).flashOffMS(), (_o).color());
    }

    ~LightConfiguration();

    void
    operator=(const LightConfiguration& _o)
    {
        Assign((_o).light(), (_o).mode(), (_o).flash(), (_o).flashOnMS(), (_o).flashOffMS(), (_o).color());
    }

    bool
    operator==(const LightConfiguration& _o) const;

    LightType&
    light()
    {
        return light_;
    }
    const LightType&
    light() const
    {
        return light_;
    }

    LightMode&
    mode()
    {
        return mode_;
    }
    const LightMode&
    mode() const
    {
        return mode_;
    }

    FlashMode&
    flash()
    {
        return flash_;
    }
    const FlashMode&
    flash() const
    {
        return flash_;
    }

    uint32_t&
    flashOnMS()
    {
        return flashOnMS_;
    }
    const uint32_t&
    flashOnMS() const
    {
        return flashOnMS_;
    }

    uint32_t&
    flashOffMS()
    {
        return flashOffMS_;
    }
    const uint32_t&
    flashOffMS() const
    {
        return flashOffMS_;
    }

    uint32_t&
    color()
    {
        return color_;
    }
    const uint32_t&
    color() const
    {
        return color_;
    }

private:
    void
    Init();

    void
    Assign(
            const LightType& _light,
            const LightMode& _mode,
            const FlashMode& _flash,
            const uint32_t& _flashOnMS,
            const uint32_t& _flashOffMS,
            const uint32_t& _color);

    LightType light_;
    LightMode mode_;
    FlashMode flash_;
    uint32_t flashOnMS_;
    uint32_t flashOffMS_;
    uint32_t color_;
};
} // namespace hal
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct SensorData|
//
namespace mozilla {
namespace hal {
class SensorData MOZ_FINAL
{
private:
    typedef mozilla::hal::SensorType SensorType;

public:
    SensorData();

    SensorData(
            const SensorType& _sensor,
            const PRTime& _timestamp,
            const InfallibleTArray<float>& _values)
    {
        Init();
        Assign(_sensor, _timestamp, _values);
    }

    SensorData(const SensorData& _o)
    {
        Init();
        Assign((_o).sensor(), (_o).timestamp(), (_o).values());
    }

    ~SensorData();

    void
    operator=(const SensorData& _o)
    {
        Assign((_o).sensor(), (_o).timestamp(), (_o).values());
    }

    bool
    operator==(const SensorData& _o) const;

    SensorType&
    sensor()
    {
        return sensor_;
    }
    const SensorType&
    sensor() const
    {
        return sensor_;
    }

    PRTime&
    timestamp()
    {
        return timestamp_;
    }
    const PRTime&
    timestamp() const
    {
        return timestamp_;
    }

    InfallibleTArray<float>&
    values()
    {
        return values_;
    }
    const InfallibleTArray<float>&
    values() const
    {
        return values_;
    }

private:
    void
    Init();

    void
    Assign(
            const SensorType& _sensor,
            const PRTime& _timestamp,
            const InfallibleTArray<float>& _values);

    SensorType sensor_;
    PRTime timestamp_;
    InfallibleTArray<float> values_;
};
} // namespace hal
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct NetworkInformation|
//
namespace mozilla {
namespace hal {
class NetworkInformation MOZ_FINAL
{
private:

public:
    NetworkInformation();

    NetworkInformation(
            const double& _bandwidth,
            const bool& _canBeMetered)
    {
        Init();
        Assign(_bandwidth, _canBeMetered);
    }

    NetworkInformation(const NetworkInformation& _o)
    {
        Init();
        Assign((_o).bandwidth(), (_o).canBeMetered());
    }

    ~NetworkInformation();

    void
    operator=(const NetworkInformation& _o)
    {
        Assign((_o).bandwidth(), (_o).canBeMetered());
    }

    bool
    operator==(const NetworkInformation& _o) const;

    double&
    bandwidth()
    {
        return bandwidth_;
    }
    const double&
    bandwidth() const
    {
        return bandwidth_;
    }

    bool&
    canBeMetered()
    {
        return canBeMetered_;
    }
    const bool&
    canBeMetered() const
    {
        return canBeMetered_;
    }

private:
    void
    Init();

    void
    Assign(
            const double& _bandwidth,
            const bool& _canBeMetered);

    double bandwidth_;
    bool canBeMetered_;
};
} // namespace hal
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct WakeLockInformation|
//
namespace mozilla {
namespace hal {
class WakeLockInformation MOZ_FINAL
{
private:

public:
    WakeLockInformation();

    WakeLockInformation(
            const uint32_t& _numLocks,
            const uint32_t& _numHidden,
            const nsString& _topic)
    {
        Init();
        Assign(_numLocks, _numHidden, _topic);
    }

    WakeLockInformation(const WakeLockInformation& _o)
    {
        Init();
        Assign((_o).numLocks(), (_o).numHidden(), (_o).topic());
    }

    ~WakeLockInformation();

    void
    operator=(const WakeLockInformation& _o)
    {
        Assign((_o).numLocks(), (_o).numHidden(), (_o).topic());
    }

    bool
    operator==(const WakeLockInformation& _o) const;

    uint32_t&
    numLocks()
    {
        return numLocks_;
    }
    const uint32_t&
    numLocks() const
    {
        return numLocks_;
    }

    uint32_t&
    numHidden()
    {
        return numHidden_;
    }
    const uint32_t&
    numHidden() const
    {
        return numHidden_;
    }

    nsString&
    topic()
    {
        return topic_;
    }
    const nsString&
    topic() const
    {
        return topic_;
    }

private:
    void
    Init();

    void
    Assign(
            const uint32_t& _numLocks,
            const uint32_t& _numHidden,
            const nsString& _topic);

    uint32_t numLocks_;
    uint32_t numHidden_;
    nsString topic_;
};
} // namespace hal
} // namespace mozilla

//-----------------------------------------------------------------------------
// Code common to PHalChild and PHalParent
//
namespace mozilla {
namespace hal_sandbox {
namespace PHal {

enum State {
    __Dead,
    __Null,
    __Error,
    __Start = __Null
};

enum MessageType {
    PHalStart = PHalMsgStart << 16,
    PHalPreStart = (PHalMsgStart << 16) - 1,
    Msg_NotifyBatteryChange__ID,
    Msg_NotifyNetworkChange__ID,
    Msg_NotifyWakeLockChange__ID,
    Msg_Vibrate__ID,
    Msg_CancelVibrate__ID,
    Msg_EnableBatteryNotifications__ID,
    Msg_DisableBatteryNotifications__ID,
    Msg_GetCurrentBatteryInformation__ID,
    Reply_GetCurrentBatteryInformation__ID,
    Msg_EnableNetworkNotifications__ID,
    Msg_DisableNetworkNotifications__ID,
    Msg_GetCurrentNetworkInformation__ID,
    Reply_GetCurrentNetworkInformation__ID,
    Msg_GetScreenEnabled__ID,
    Reply_GetScreenEnabled__ID,
    Msg_SetScreenEnabled__ID,
    Msg_GetScreenBrightness__ID,
    Reply_GetScreenBrightness__ID,
    Msg_SetScreenBrightness__ID,
    Msg_AdjustSystemClock__ID,
    Msg_SetTimezone__ID,
    Msg_SetLight__ID,
    Reply_SetLight__ID,
    Msg_GetLight__ID,
    Reply_GetLight__ID,
    Msg_Reboot__ID,
    Msg_PowerOff__ID,
    Msg_ModifyWakeLock__ID,
    Msg_EnableWakeLockNotifications__ID,
    Msg_DisableWakeLockNotifications__ID,
    Msg_GetWakeLockInfo__ID,
    Reply_GetWakeLockInfo__ID,
    Msg_NotifySensorChange__ID,
    Msg_EnableSensorNotifications__ID,
    Msg_DisableSensorNotifications__ID,
    Msg___delete____ID,
    Reply___delete____ID,
    PHalEnd
};

bool
Transition(
        State from,
        mozilla::ipc::Trigger trigger,
        State* next);

class Msg_NotifyBatteryChange :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::hal::BatteryInformation BatteryInformation;
    typedef mozilla::hal::LightConfiguration LightConfiguration;
    typedef mozilla::hal::SensorData SensorData;
    typedef mozilla::hal::NetworkInformation NetworkInformation;
    typedef mozilla::hal::WakeLockInformation WakeLockInformation;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::hal::FlashMode FlashMode;
    typedef mozilla::hal::LightType LightType;
    typedef mozilla::hal::LightMode LightMode;
    typedef mozilla::hal::SensorType SensorType;
    typedef mozilla::hal::WakeLockControl WakeLockControl;

public:
    enum {
        ID = Msg_NotifyBatteryChange__ID
    };
    Msg_NotifyBatteryChange() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHal::Msg_NotifyBatteryChange")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_NotifyBatteryChange(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_NotifyNetworkChange :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::hal::BatteryInformation BatteryInformation;
    typedef mozilla::hal::LightConfiguration LightConfiguration;
    typedef mozilla::hal::SensorData SensorData;
    typedef mozilla::hal::NetworkInformation NetworkInformation;
    typedef mozilla::hal::WakeLockInformation WakeLockInformation;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::hal::FlashMode FlashMode;
    typedef mozilla::hal::LightType LightType;
    typedef mozilla::hal::LightMode LightMode;
    typedef mozilla::hal::SensorType SensorType;
    typedef mozilla::hal::WakeLockControl WakeLockControl;

public:
    enum {
        ID = Msg_NotifyNetworkChange__ID
    };
    Msg_NotifyNetworkChange() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHal::Msg_NotifyNetworkChange")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_NotifyNetworkChange(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_NotifyWakeLockChange :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::hal::BatteryInformation BatteryInformation;
    typedef mozilla::hal::LightConfiguration LightConfiguration;
    typedef mozilla::hal::SensorData SensorData;
    typedef mozilla::hal::NetworkInformation NetworkInformation;
    typedef mozilla::hal::WakeLockInformation WakeLockInformation;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::hal::FlashMode FlashMode;
    typedef mozilla::hal::LightType LightType;
    typedef mozilla::hal::LightMode LightMode;
    typedef mozilla::hal::SensorType SensorType;
    typedef mozilla::hal::WakeLockControl WakeLockControl;

public:
    enum {
        ID = Msg_NotifyWakeLockChange__ID
    };
    Msg_NotifyWakeLockChange() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHal::Msg_NotifyWakeLockChange")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_NotifyWakeLockChange(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_Vibrate :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::hal::BatteryInformation BatteryInformation;
    typedef mozilla::hal::LightConfiguration LightConfiguration;
    typedef mozilla::hal::SensorData SensorData;
    typedef mozilla::hal::NetworkInformation NetworkInformation;
    typedef mozilla::hal::WakeLockInformation WakeLockInformation;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::hal::FlashMode FlashMode;
    typedef mozilla::hal::LightType LightType;
    typedef mozilla::hal::LightMode LightMode;
    typedef mozilla::hal::SensorType SensorType;
    typedef mozilla::hal::WakeLockControl WakeLockControl;

public:
    enum {
        ID = Msg_Vibrate__ID
    };
    Msg_Vibrate() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHal::Msg_Vibrate")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_Vibrate(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_CancelVibrate :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::hal::BatteryInformation BatteryInformation;
    typedef mozilla::hal::LightConfiguration LightConfiguration;
    typedef mozilla::hal::SensorData SensorData;
    typedef mozilla::hal::NetworkInformation NetworkInformation;
    typedef mozilla::hal::WakeLockInformation WakeLockInformation;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::hal::FlashMode FlashMode;
    typedef mozilla::hal::LightType LightType;
    typedef mozilla::hal::LightMode LightMode;
    typedef mozilla::hal::SensorType SensorType;
    typedef mozilla::hal::WakeLockControl WakeLockControl;

public:
    enum {
        ID = Msg_CancelVibrate__ID
    };
    Msg_CancelVibrate() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHal::Msg_CancelVibrate")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_CancelVibrate(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_EnableBatteryNotifications :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::hal::BatteryInformation BatteryInformation;
    typedef mozilla::hal::LightConfiguration LightConfiguration;
    typedef mozilla::hal::SensorData SensorData;
    typedef mozilla::hal::NetworkInformation NetworkInformation;
    typedef mozilla::hal::WakeLockInformation WakeLockInformation;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::hal::FlashMode FlashMode;
    typedef mozilla::hal::LightType LightType;
    typedef mozilla::hal::LightMode LightMode;
    typedef mozilla::hal::SensorType SensorType;
    typedef mozilla::hal::WakeLockControl WakeLockControl;

public:
    enum {
        ID = Msg_EnableBatteryNotifications__ID
    };
    Msg_EnableBatteryNotifications() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHal::Msg_EnableBatteryNotifications")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_EnableBatteryNotifications(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_DisableBatteryNotifications :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::hal::BatteryInformation BatteryInformation;
    typedef mozilla::hal::LightConfiguration LightConfiguration;
    typedef mozilla::hal::SensorData SensorData;
    typedef mozilla::hal::NetworkInformation NetworkInformation;
    typedef mozilla::hal::WakeLockInformation WakeLockInformation;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::hal::FlashMode FlashMode;
    typedef mozilla::hal::LightType LightType;
    typedef mozilla::hal::LightMode LightMode;
    typedef mozilla::hal::SensorType SensorType;
    typedef mozilla::hal::WakeLockControl WakeLockControl;

public:
    enum {
        ID = Msg_DisableBatteryNotifications__ID
    };
    Msg_DisableBatteryNotifications() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHal::Msg_DisableBatteryNotifications")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_DisableBatteryNotifications(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_GetCurrentBatteryInformation :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::hal::BatteryInformation BatteryInformation;
    typedef mozilla::hal::LightConfiguration LightConfiguration;
    typedef mozilla::hal::SensorData SensorData;
    typedef mozilla::hal::NetworkInformation NetworkInformation;
    typedef mozilla::hal::WakeLockInformation WakeLockInformation;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::hal::FlashMode FlashMode;
    typedef mozilla::hal::LightType LightType;
    typedef mozilla::hal::LightMode LightMode;
    typedef mozilla::hal::SensorType SensorType;
    typedef mozilla::hal::WakeLockControl WakeLockControl;

public:
    enum {
        ID = Msg_GetCurrentBatteryInformation__ID
    };
    Msg_GetCurrentBatteryInformation() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHal::Msg_GetCurrentBatteryInformation")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_GetCurrentBatteryInformation(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_GetCurrentBatteryInformation :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::hal::BatteryInformation BatteryInformation;
    typedef mozilla::hal::LightConfiguration LightConfiguration;
    typedef mozilla::hal::SensorData SensorData;
    typedef mozilla::hal::NetworkInformation NetworkInformation;
    typedef mozilla::hal::WakeLockInformation WakeLockInformation;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::hal::FlashMode FlashMode;
    typedef mozilla::hal::LightType LightType;
    typedef mozilla::hal::LightMode LightMode;
    typedef mozilla::hal::SensorType SensorType;
    typedef mozilla::hal::WakeLockControl WakeLockControl;

public:
    enum {
        ID = Reply_GetCurrentBatteryInformation__ID
    };
    Reply_GetCurrentBatteryInformation() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHal::Reply_GetCurrentBatteryInformation")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_GetCurrentBatteryInformation(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_EnableNetworkNotifications :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::hal::BatteryInformation BatteryInformation;
    typedef mozilla::hal::LightConfiguration LightConfiguration;
    typedef mozilla::hal::SensorData SensorData;
    typedef mozilla::hal::NetworkInformation NetworkInformation;
    typedef mozilla::hal::WakeLockInformation WakeLockInformation;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::hal::FlashMode FlashMode;
    typedef mozilla::hal::LightType LightType;
    typedef mozilla::hal::LightMode LightMode;
    typedef mozilla::hal::SensorType SensorType;
    typedef mozilla::hal::WakeLockControl WakeLockControl;

public:
    enum {
        ID = Msg_EnableNetworkNotifications__ID
    };
    Msg_EnableNetworkNotifications() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHal::Msg_EnableNetworkNotifications")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_EnableNetworkNotifications(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_DisableNetworkNotifications :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::hal::BatteryInformation BatteryInformation;
    typedef mozilla::hal::LightConfiguration LightConfiguration;
    typedef mozilla::hal::SensorData SensorData;
    typedef mozilla::hal::NetworkInformation NetworkInformation;
    typedef mozilla::hal::WakeLockInformation WakeLockInformation;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::hal::FlashMode FlashMode;
    typedef mozilla::hal::LightType LightType;
    typedef mozilla::hal::LightMode LightMode;
    typedef mozilla::hal::SensorType SensorType;
    typedef mozilla::hal::WakeLockControl WakeLockControl;

public:
    enum {
        ID = Msg_DisableNetworkNotifications__ID
    };
    Msg_DisableNetworkNotifications() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHal::Msg_DisableNetworkNotifications")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_DisableNetworkNotifications(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_GetCurrentNetworkInformation :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::hal::BatteryInformation BatteryInformation;
    typedef mozilla::hal::LightConfiguration LightConfiguration;
    typedef mozilla::hal::SensorData SensorData;
    typedef mozilla::hal::NetworkInformation NetworkInformation;
    typedef mozilla::hal::WakeLockInformation WakeLockInformation;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::hal::FlashMode FlashMode;
    typedef mozilla::hal::LightType LightType;
    typedef mozilla::hal::LightMode LightMode;
    typedef mozilla::hal::SensorType SensorType;
    typedef mozilla::hal::WakeLockControl WakeLockControl;

public:
    enum {
        ID = Msg_GetCurrentNetworkInformation__ID
    };
    Msg_GetCurrentNetworkInformation() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHal::Msg_GetCurrentNetworkInformation")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_GetCurrentNetworkInformation(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_GetCurrentNetworkInformation :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::hal::BatteryInformation BatteryInformation;
    typedef mozilla::hal::LightConfiguration LightConfiguration;
    typedef mozilla::hal::SensorData SensorData;
    typedef mozilla::hal::NetworkInformation NetworkInformation;
    typedef mozilla::hal::WakeLockInformation WakeLockInformation;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::hal::FlashMode FlashMode;
    typedef mozilla::hal::LightType LightType;
    typedef mozilla::hal::LightMode LightMode;
    typedef mozilla::hal::SensorType SensorType;
    typedef mozilla::hal::WakeLockControl WakeLockControl;

public:
    enum {
        ID = Reply_GetCurrentNetworkInformation__ID
    };
    Reply_GetCurrentNetworkInformation() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHal::Reply_GetCurrentNetworkInformation")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_GetCurrentNetworkInformation(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_GetScreenEnabled :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::hal::BatteryInformation BatteryInformation;
    typedef mozilla::hal::LightConfiguration LightConfiguration;
    typedef mozilla::hal::SensorData SensorData;
    typedef mozilla::hal::NetworkInformation NetworkInformation;
    typedef mozilla::hal::WakeLockInformation WakeLockInformation;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::hal::FlashMode FlashMode;
    typedef mozilla::hal::LightType LightType;
    typedef mozilla::hal::LightMode LightMode;
    typedef mozilla::hal::SensorType SensorType;
    typedef mozilla::hal::WakeLockControl WakeLockControl;

public:
    enum {
        ID = Msg_GetScreenEnabled__ID
    };
    Msg_GetScreenEnabled() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHal::Msg_GetScreenEnabled")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_GetScreenEnabled(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_GetScreenEnabled :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::hal::BatteryInformation BatteryInformation;
    typedef mozilla::hal::LightConfiguration LightConfiguration;
    typedef mozilla::hal::SensorData SensorData;
    typedef mozilla::hal::NetworkInformation NetworkInformation;
    typedef mozilla::hal::WakeLockInformation WakeLockInformation;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::hal::FlashMode FlashMode;
    typedef mozilla::hal::LightType LightType;
    typedef mozilla::hal::LightMode LightMode;
    typedef mozilla::hal::SensorType SensorType;
    typedef mozilla::hal::WakeLockControl WakeLockControl;

public:
    enum {
        ID = Reply_GetScreenEnabled__ID
    };
    Reply_GetScreenEnabled() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHal::Reply_GetScreenEnabled")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_GetScreenEnabled(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_SetScreenEnabled :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::hal::BatteryInformation BatteryInformation;
    typedef mozilla::hal::LightConfiguration LightConfiguration;
    typedef mozilla::hal::SensorData SensorData;
    typedef mozilla::hal::NetworkInformation NetworkInformation;
    typedef mozilla::hal::WakeLockInformation WakeLockInformation;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::hal::FlashMode FlashMode;
    typedef mozilla::hal::LightType LightType;
    typedef mozilla::hal::LightMode LightMode;
    typedef mozilla::hal::SensorType SensorType;
    typedef mozilla::hal::WakeLockControl WakeLockControl;

public:
    enum {
        ID = Msg_SetScreenEnabled__ID
    };
    Msg_SetScreenEnabled() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHal::Msg_SetScreenEnabled")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_SetScreenEnabled(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_GetScreenBrightness :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::hal::BatteryInformation BatteryInformation;
    typedef mozilla::hal::LightConfiguration LightConfiguration;
    typedef mozilla::hal::SensorData SensorData;
    typedef mozilla::hal::NetworkInformation NetworkInformation;
    typedef mozilla::hal::WakeLockInformation WakeLockInformation;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::hal::FlashMode FlashMode;
    typedef mozilla::hal::LightType LightType;
    typedef mozilla::hal::LightMode LightMode;
    typedef mozilla::hal::SensorType SensorType;
    typedef mozilla::hal::WakeLockControl WakeLockControl;

public:
    enum {
        ID = Msg_GetScreenBrightness__ID
    };
    Msg_GetScreenBrightness() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHal::Msg_GetScreenBrightness")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_GetScreenBrightness(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_GetScreenBrightness :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::hal::BatteryInformation BatteryInformation;
    typedef mozilla::hal::LightConfiguration LightConfiguration;
    typedef mozilla::hal::SensorData SensorData;
    typedef mozilla::hal::NetworkInformation NetworkInformation;
    typedef mozilla::hal::WakeLockInformation WakeLockInformation;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::hal::FlashMode FlashMode;
    typedef mozilla::hal::LightType LightType;
    typedef mozilla::hal::LightMode LightMode;
    typedef mozilla::hal::SensorType SensorType;
    typedef mozilla::hal::WakeLockControl WakeLockControl;

public:
    enum {
        ID = Reply_GetScreenBrightness__ID
    };
    Reply_GetScreenBrightness() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHal::Reply_GetScreenBrightness")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_GetScreenBrightness(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_SetScreenBrightness :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::hal::BatteryInformation BatteryInformation;
    typedef mozilla::hal::LightConfiguration LightConfiguration;
    typedef mozilla::hal::SensorData SensorData;
    typedef mozilla::hal::NetworkInformation NetworkInformation;
    typedef mozilla::hal::WakeLockInformation WakeLockInformation;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::hal::FlashMode FlashMode;
    typedef mozilla::hal::LightType LightType;
    typedef mozilla::hal::LightMode LightMode;
    typedef mozilla::hal::SensorType SensorType;
    typedef mozilla::hal::WakeLockControl WakeLockControl;

public:
    enum {
        ID = Msg_SetScreenBrightness__ID
    };
    Msg_SetScreenBrightness() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHal::Msg_SetScreenBrightness")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_SetScreenBrightness(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_AdjustSystemClock :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::hal::BatteryInformation BatteryInformation;
    typedef mozilla::hal::LightConfiguration LightConfiguration;
    typedef mozilla::hal::SensorData SensorData;
    typedef mozilla::hal::NetworkInformation NetworkInformation;
    typedef mozilla::hal::WakeLockInformation WakeLockInformation;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::hal::FlashMode FlashMode;
    typedef mozilla::hal::LightType LightType;
    typedef mozilla::hal::LightMode LightMode;
    typedef mozilla::hal::SensorType SensorType;
    typedef mozilla::hal::WakeLockControl WakeLockControl;

public:
    enum {
        ID = Msg_AdjustSystemClock__ID
    };
    Msg_AdjustSystemClock() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHal::Msg_AdjustSystemClock")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_AdjustSystemClock(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_SetTimezone :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::hal::BatteryInformation BatteryInformation;
    typedef mozilla::hal::LightConfiguration LightConfiguration;
    typedef mozilla::hal::SensorData SensorData;
    typedef mozilla::hal::NetworkInformation NetworkInformation;
    typedef mozilla::hal::WakeLockInformation WakeLockInformation;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::hal::FlashMode FlashMode;
    typedef mozilla::hal::LightType LightType;
    typedef mozilla::hal::LightMode LightMode;
    typedef mozilla::hal::SensorType SensorType;
    typedef mozilla::hal::WakeLockControl WakeLockControl;

public:
    enum {
        ID = Msg_SetTimezone__ID
    };
    Msg_SetTimezone() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHal::Msg_SetTimezone")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_SetTimezone(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_SetLight :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::hal::BatteryInformation BatteryInformation;
    typedef mozilla::hal::LightConfiguration LightConfiguration;
    typedef mozilla::hal::SensorData SensorData;
    typedef mozilla::hal::NetworkInformation NetworkInformation;
    typedef mozilla::hal::WakeLockInformation WakeLockInformation;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::hal::FlashMode FlashMode;
    typedef mozilla::hal::LightType LightType;
    typedef mozilla::hal::LightMode LightMode;
    typedef mozilla::hal::SensorType SensorType;
    typedef mozilla::hal::WakeLockControl WakeLockControl;

public:
    enum {
        ID = Msg_SetLight__ID
    };
    Msg_SetLight() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHal::Msg_SetLight")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_SetLight(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_SetLight :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::hal::BatteryInformation BatteryInformation;
    typedef mozilla::hal::LightConfiguration LightConfiguration;
    typedef mozilla::hal::SensorData SensorData;
    typedef mozilla::hal::NetworkInformation NetworkInformation;
    typedef mozilla::hal::WakeLockInformation WakeLockInformation;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::hal::FlashMode FlashMode;
    typedef mozilla::hal::LightType LightType;
    typedef mozilla::hal::LightMode LightMode;
    typedef mozilla::hal::SensorType SensorType;
    typedef mozilla::hal::WakeLockControl WakeLockControl;

public:
    enum {
        ID = Reply_SetLight__ID
    };
    Reply_SetLight() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHal::Reply_SetLight")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_SetLight(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_GetLight :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::hal::BatteryInformation BatteryInformation;
    typedef mozilla::hal::LightConfiguration LightConfiguration;
    typedef mozilla::hal::SensorData SensorData;
    typedef mozilla::hal::NetworkInformation NetworkInformation;
    typedef mozilla::hal::WakeLockInformation WakeLockInformation;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::hal::FlashMode FlashMode;
    typedef mozilla::hal::LightType LightType;
    typedef mozilla::hal::LightMode LightMode;
    typedef mozilla::hal::SensorType SensorType;
    typedef mozilla::hal::WakeLockControl WakeLockControl;

public:
    enum {
        ID = Msg_GetLight__ID
    };
    Msg_GetLight() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHal::Msg_GetLight")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_GetLight(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_GetLight :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::hal::BatteryInformation BatteryInformation;
    typedef mozilla::hal::LightConfiguration LightConfiguration;
    typedef mozilla::hal::SensorData SensorData;
    typedef mozilla::hal::NetworkInformation NetworkInformation;
    typedef mozilla::hal::WakeLockInformation WakeLockInformation;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::hal::FlashMode FlashMode;
    typedef mozilla::hal::LightType LightType;
    typedef mozilla::hal::LightMode LightMode;
    typedef mozilla::hal::SensorType SensorType;
    typedef mozilla::hal::WakeLockControl WakeLockControl;

public:
    enum {
        ID = Reply_GetLight__ID
    };
    Reply_GetLight() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHal::Reply_GetLight")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_GetLight(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_Reboot :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::hal::BatteryInformation BatteryInformation;
    typedef mozilla::hal::LightConfiguration LightConfiguration;
    typedef mozilla::hal::SensorData SensorData;
    typedef mozilla::hal::NetworkInformation NetworkInformation;
    typedef mozilla::hal::WakeLockInformation WakeLockInformation;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::hal::FlashMode FlashMode;
    typedef mozilla::hal::LightType LightType;
    typedef mozilla::hal::LightMode LightMode;
    typedef mozilla::hal::SensorType SensorType;
    typedef mozilla::hal::WakeLockControl WakeLockControl;

public:
    enum {
        ID = Msg_Reboot__ID
    };
    Msg_Reboot() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHal::Msg_Reboot")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_Reboot(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_PowerOff :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::hal::BatteryInformation BatteryInformation;
    typedef mozilla::hal::LightConfiguration LightConfiguration;
    typedef mozilla::hal::SensorData SensorData;
    typedef mozilla::hal::NetworkInformation NetworkInformation;
    typedef mozilla::hal::WakeLockInformation WakeLockInformation;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::hal::FlashMode FlashMode;
    typedef mozilla::hal::LightType LightType;
    typedef mozilla::hal::LightMode LightMode;
    typedef mozilla::hal::SensorType SensorType;
    typedef mozilla::hal::WakeLockControl WakeLockControl;

public:
    enum {
        ID = Msg_PowerOff__ID
    };
    Msg_PowerOff() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHal::Msg_PowerOff")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_PowerOff(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_ModifyWakeLock :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::hal::BatteryInformation BatteryInformation;
    typedef mozilla::hal::LightConfiguration LightConfiguration;
    typedef mozilla::hal::SensorData SensorData;
    typedef mozilla::hal::NetworkInformation NetworkInformation;
    typedef mozilla::hal::WakeLockInformation WakeLockInformation;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::hal::FlashMode FlashMode;
    typedef mozilla::hal::LightType LightType;
    typedef mozilla::hal::LightMode LightMode;
    typedef mozilla::hal::SensorType SensorType;
    typedef mozilla::hal::WakeLockControl WakeLockControl;

public:
    enum {
        ID = Msg_ModifyWakeLock__ID
    };
    Msg_ModifyWakeLock() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHal::Msg_ModifyWakeLock")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_ModifyWakeLock(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_EnableWakeLockNotifications :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::hal::BatteryInformation BatteryInformation;
    typedef mozilla::hal::LightConfiguration LightConfiguration;
    typedef mozilla::hal::SensorData SensorData;
    typedef mozilla::hal::NetworkInformation NetworkInformation;
    typedef mozilla::hal::WakeLockInformation WakeLockInformation;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::hal::FlashMode FlashMode;
    typedef mozilla::hal::LightType LightType;
    typedef mozilla::hal::LightMode LightMode;
    typedef mozilla::hal::SensorType SensorType;
    typedef mozilla::hal::WakeLockControl WakeLockControl;

public:
    enum {
        ID = Msg_EnableWakeLockNotifications__ID
    };
    Msg_EnableWakeLockNotifications() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHal::Msg_EnableWakeLockNotifications")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_EnableWakeLockNotifications(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_DisableWakeLockNotifications :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::hal::BatteryInformation BatteryInformation;
    typedef mozilla::hal::LightConfiguration LightConfiguration;
    typedef mozilla::hal::SensorData SensorData;
    typedef mozilla::hal::NetworkInformation NetworkInformation;
    typedef mozilla::hal::WakeLockInformation WakeLockInformation;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::hal::FlashMode FlashMode;
    typedef mozilla::hal::LightType LightType;
    typedef mozilla::hal::LightMode LightMode;
    typedef mozilla::hal::SensorType SensorType;
    typedef mozilla::hal::WakeLockControl WakeLockControl;

public:
    enum {
        ID = Msg_DisableWakeLockNotifications__ID
    };
    Msg_DisableWakeLockNotifications() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHal::Msg_DisableWakeLockNotifications")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_DisableWakeLockNotifications(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_GetWakeLockInfo :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::hal::BatteryInformation BatteryInformation;
    typedef mozilla::hal::LightConfiguration LightConfiguration;
    typedef mozilla::hal::SensorData SensorData;
    typedef mozilla::hal::NetworkInformation NetworkInformation;
    typedef mozilla::hal::WakeLockInformation WakeLockInformation;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::hal::FlashMode FlashMode;
    typedef mozilla::hal::LightType LightType;
    typedef mozilla::hal::LightMode LightMode;
    typedef mozilla::hal::SensorType SensorType;
    typedef mozilla::hal::WakeLockControl WakeLockControl;

public:
    enum {
        ID = Msg_GetWakeLockInfo__ID
    };
    Msg_GetWakeLockInfo() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHal::Msg_GetWakeLockInfo")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_GetWakeLockInfo(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_GetWakeLockInfo :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::hal::BatteryInformation BatteryInformation;
    typedef mozilla::hal::LightConfiguration LightConfiguration;
    typedef mozilla::hal::SensorData SensorData;
    typedef mozilla::hal::NetworkInformation NetworkInformation;
    typedef mozilla::hal::WakeLockInformation WakeLockInformation;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::hal::FlashMode FlashMode;
    typedef mozilla::hal::LightType LightType;
    typedef mozilla::hal::LightMode LightMode;
    typedef mozilla::hal::SensorType SensorType;
    typedef mozilla::hal::WakeLockControl WakeLockControl;

public:
    enum {
        ID = Reply_GetWakeLockInfo__ID
    };
    Reply_GetWakeLockInfo() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHal::Reply_GetWakeLockInfo")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_GetWakeLockInfo(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_NotifySensorChange :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::hal::BatteryInformation BatteryInformation;
    typedef mozilla::hal::LightConfiguration LightConfiguration;
    typedef mozilla::hal::SensorData SensorData;
    typedef mozilla::hal::NetworkInformation NetworkInformation;
    typedef mozilla::hal::WakeLockInformation WakeLockInformation;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::hal::FlashMode FlashMode;
    typedef mozilla::hal::LightType LightType;
    typedef mozilla::hal::LightMode LightMode;
    typedef mozilla::hal::SensorType SensorType;
    typedef mozilla::hal::WakeLockControl WakeLockControl;

public:
    enum {
        ID = Msg_NotifySensorChange__ID
    };
    Msg_NotifySensorChange() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHal::Msg_NotifySensorChange")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_NotifySensorChange(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_EnableSensorNotifications :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::hal::BatteryInformation BatteryInformation;
    typedef mozilla::hal::LightConfiguration LightConfiguration;
    typedef mozilla::hal::SensorData SensorData;
    typedef mozilla::hal::NetworkInformation NetworkInformation;
    typedef mozilla::hal::WakeLockInformation WakeLockInformation;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::hal::FlashMode FlashMode;
    typedef mozilla::hal::LightType LightType;
    typedef mozilla::hal::LightMode LightMode;
    typedef mozilla::hal::SensorType SensorType;
    typedef mozilla::hal::WakeLockControl WakeLockControl;

public:
    enum {
        ID = Msg_EnableSensorNotifications__ID
    };
    Msg_EnableSensorNotifications() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHal::Msg_EnableSensorNotifications")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_EnableSensorNotifications(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_DisableSensorNotifications :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::hal::BatteryInformation BatteryInformation;
    typedef mozilla::hal::LightConfiguration LightConfiguration;
    typedef mozilla::hal::SensorData SensorData;
    typedef mozilla::hal::NetworkInformation NetworkInformation;
    typedef mozilla::hal::WakeLockInformation WakeLockInformation;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::hal::FlashMode FlashMode;
    typedef mozilla::hal::LightType LightType;
    typedef mozilla::hal::LightMode LightMode;
    typedef mozilla::hal::SensorType SensorType;
    typedef mozilla::hal::WakeLockControl WakeLockControl;

public:
    enum {
        ID = Msg_DisableSensorNotifications__ID
    };
    Msg_DisableSensorNotifications() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHal::Msg_DisableSensorNotifications")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_DisableSensorNotifications(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg___delete__ :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::hal::BatteryInformation BatteryInformation;
    typedef mozilla::hal::LightConfiguration LightConfiguration;
    typedef mozilla::hal::SensorData SensorData;
    typedef mozilla::hal::NetworkInformation NetworkInformation;
    typedef mozilla::hal::WakeLockInformation WakeLockInformation;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::hal::FlashMode FlashMode;
    typedef mozilla::hal::LightType LightType;
    typedef mozilla::hal::LightMode LightMode;
    typedef mozilla::hal::SensorType SensorType;
    typedef mozilla::hal::WakeLockControl WakeLockControl;

public:
    enum {
        ID = Msg___delete____ID
    };
    Msg___delete__() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHal::Msg___delete__")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg___delete__(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply___delete__ :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::hal::BatteryInformation BatteryInformation;
    typedef mozilla::hal::LightConfiguration LightConfiguration;
    typedef mozilla::hal::SensorData SensorData;
    typedef mozilla::hal::NetworkInformation NetworkInformation;
    typedef mozilla::hal::WakeLockInformation WakeLockInformation;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::hal::FlashMode FlashMode;
    typedef mozilla::hal::LightType LightType;
    typedef mozilla::hal::LightMode LightMode;
    typedef mozilla::hal::SensorType SensorType;
    typedef mozilla::hal::WakeLockControl WakeLockControl;

public:
    enum {
        ID = Reply___delete____ID
    };
    Reply___delete__() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHal::Reply___delete__")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply___delete__(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};



} // namespace PHal
} // namespace hal_sandbox
} // namespace mozilla

#endif // ifndef PHal_h
