//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PHalChild_h
#define PHalChild_h

#include "mozilla/hal_sandbox/PHal.h"
namespace mozilla {
namespace dom {
class PContentChild;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PBrowserChild;
} // namespace dom
} // namespace mozilla

#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/RPCChannel.h"


namespace mozilla {
namespace dom {
class PContentChild;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace hal_sandbox {


class /*NS_ABSTRACT_CLASS*/ PHalChild :
    protected mozilla::ipc::RPCChannel::RPCListener,
    protected mozilla::ipc::IProtocolManager<mozilla::ipc::RPCChannel::RPCListener>
{
    friend class mozilla::dom::PContentChild;

protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::hal::BatteryInformation BatteryInformation;
    typedef mozilla::hal::LightConfiguration LightConfiguration;
    typedef mozilla::hal::SensorData SensorData;
    typedef mozilla::hal::NetworkInformation NetworkInformation;
    typedef mozilla::hal::WakeLockInformation WakeLockInformation;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::hal::FlashMode FlashMode;
    typedef mozilla::hal::LightType LightType;
    typedef mozilla::hal::LightMode LightMode;
    typedef mozilla::hal::SensorType SensorType;
    typedef mozilla::hal::WakeLockControl WakeLockControl;
    typedef mozilla::dom::PContentChild PContentChild;
    typedef mozilla::dom::PBrowserChild PBrowserChild;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;

    typedef PHal::State State;

    virtual bool
    RecvNotifyBatteryChange(const BatteryInformation& aBatteryInfo) = 0;
    virtual bool
    RecvNotifyNetworkChange(const NetworkInformation& aNetworkInfo) = 0;
    virtual bool
    RecvNotifyWakeLockChange(const WakeLockInformation& aWakeLockInfo) = 0;
    virtual bool
    RecvNotifySensorChange(const SensorData& aSensorData) = 0;

    virtual void
    ActorDestroy(ActorDestroyReason why);

public:
    typedef IPC::Message Message;
    typedef mozilla::ipc::RPCChannel Channel;
    typedef mozilla::ipc::RPCChannel::RPCListener ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::AsyncChannel AsyncChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;

public:
    PHalChild();

    virtual ~PHalChild();

    PContentChild*
    Manager();

    PHal::State
    state();

    bool
    SendVibrate(
            const InfallibleTArray<uint32>& pattern,
            const InfallibleTArray<uint64>& id,
            PBrowserChild* browser);

    bool
    SendCancelVibrate(
            const InfallibleTArray<uint64>& id,
            PBrowserChild* browser);

    bool
    SendEnableBatteryNotifications();

    bool
    SendDisableBatteryNotifications();

    bool
    SendGetCurrentBatteryInformation(BatteryInformation* aBatteryInfo);

    bool
    SendEnableNetworkNotifications();

    bool
    SendDisableNetworkNotifications();

    bool
    SendGetCurrentNetworkInformation(NetworkInformation* aNetworkInfo);

    bool
    SendGetScreenEnabled(bool* enabled);

    bool
    SendSetScreenEnabled(const bool& enabled);

    bool
    SendGetScreenBrightness(double* brightness);

    bool
    SendSetScreenBrightness(const double& brightness);

    bool
    SendAdjustSystemClock(const int32& aDeltaMilliseconds);

    bool
    SendSetTimezone(const nsCString& aTimezoneSpec);

    bool
    SendSetLight(
            const LightType& light,
            const LightConfiguration& aConfig,
            bool* status);

    bool
    SendGetLight(
            const LightType& light,
            LightConfiguration* aConfig,
            bool* status);

    bool
    SendReboot();

    bool
    SendPowerOff();

    bool
    SendModifyWakeLock(
            const nsString& aTopic,
            const WakeLockControl& aLockAdjust,
            const WakeLockControl& aHiddenAdjust);

    bool
    SendEnableWakeLockNotifications();

    bool
    SendDisableWakeLockNotifications();

    bool
    SendGetWakeLockInfo(
            const nsString& aTopic,
            WakeLockInformation* aWakeLockInfo);

    bool
    SendEnableSensorNotifications(const SensorType& aSensor);

    bool
    SendDisableSensorNotifications(const SensorType& aSensor);

    static bool
    Send__delete__(PHalChild* actor);

    virtual int32
    Register(ChannelListener* aRouted);
    virtual int32
    RegisterID(
            ChannelListener* aRouted,
            int32 aId);
    virtual ChannelListener*
    Lookup(int32 aId);
    virtual void
    Unregister(int32 aId);
    virtual void
    RemoveManagee(
            int32 aProtocolId,
            ChannelListener* aListener);
    virtual Shmem::SharedMemory*
    CreateSharedMemory(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType type,
            bool unsafe,
            Shmem::id_t* aId);
    virtual bool
    AdoptSharedMemory(
            Shmem::SharedMemory* segment,
            Shmem::id_t* aId);
    virtual Shmem::SharedMemory*
    LookupSharedMemory(Shmem::id_t aId);
    virtual bool
    IsTrackingSharedMemory(Shmem::SharedMemory* segment);
    virtual bool
    DestroySharedMemory(Shmem& aShmem);
    virtual ProcessHandle
    OtherProcess() const;
    virtual AsyncChannel*
    GetIPCChannel();

    virtual Result
    OnMessageReceived(const Message& __msg);

    virtual Result
    OnMessageReceived(
            const Message& __msg,
            Message*& __reply);

    virtual Result
    OnCallReceived(
            const Message& __msg,
            Message*& __reply);

    void
    OnProcessingError(Result code);

    bool
    OnReplyTimeout();

    void
    OnChannelClose();

    void
    OnChannelError();

    void
    OnChannelConnected(int32 pid);

    // Methods for managing shmem
    bool
    AllocShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aMem);

    bool
    AllocUnsafeShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aMem);

    bool
    AdoptShmem(
            Shmem& aMem,
            Shmem* aOutMem);

    bool
    DeallocShmem(Shmem& aMem);

private:
    virtual void
    FatalError(const char* const msg) const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& __v,
            Message* __msg)
    {
        IPC::WriteParam(__msg, __v);
    }

    template<typename T>
    bool
    Read(
            T* __v,
            const Message* __msg,
            void** __iter)
    {
        return IPC::ReadParam(__msg, __iter, __v);
    }

    void
    Write(
            const LightConfiguration& __v,
            Message* __msg);

    bool
    Read(
            LightConfiguration* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            PBrowserChild* __v,
            Message* __msg,
            bool __nullable);

    bool
    Read(
            PBrowserChild** __v,
            const Message* __msg,
            void** __iter,
            bool __nullable) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const BatteryInformation& __v,
            Message* __msg);

    bool
    Read(
            BatteryInformation* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const WakeLockInformation& __v,
            Message* __msg);

    bool
    Read(
            WakeLockInformation* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const NetworkInformation& __v,
            Message* __msg);

    bool
    Read(
            NetworkInformation* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const SensorData& __v,
            Message* __msg);

    bool
    Read(
            SensorData* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            PHalChild* __v,
            Message* __msg,
            bool __nullable);

    bool
    Read(
            PHalChild** __v,
            const Message* __msg,
            void** __iter,
            bool __nullable) NS_WARN_UNUSED_RESULT;

    Channel* mChannel;
    int32 mId;
    mozilla::ipc::IProtocolManager<mozilla::ipc::RPCChannel::RPCListener>* mManager;
    State mState;
};


} // namespace hal_sandbox
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace hal_sandbox {
class HalChild :
    public PHalChild
{
    virtual bool
    RecvNotifyBatteryChange(const BatteryInformation& aBatteryInfo);

    virtual bool
    RecvNotifyNetworkChange(const NetworkInformation& aNetworkInfo);

    virtual bool
    RecvNotifyWakeLockChange(const WakeLockInformation& aWakeLockInfo);

    virtual bool
    RecvNotifySensorChange(const SensorData& aSensorData);

    HalChild();
    virtual ~HalChild();
};
} // namespace hal_sandbox
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace hal_sandbox {
bool
HalChild::RecvNotifyBatteryChange(const BatteryInformation& aBatteryInfo)
{
    return false;
}

bool
HalChild::RecvNotifyNetworkChange(const NetworkInformation& aNetworkInfo)
{
    return false;
}

bool
HalChild::RecvNotifyWakeLockChange(const WakeLockInformation& aWakeLockInfo)
{
    return false;
}

bool
HalChild::RecvNotifySensorChange(const SensorData& aSensorData)
{
    return false;
}

HalChild::HalChild()
{
    MOZ_COUNT_CTOR(HalChild);
}

HalChild::~HalChild()
{
    MOZ_COUNT_DTOR(HalChild);
}

} // namespace hal_sandbox
} // namespace mozilla
#endif // if 0

#endif // ifndef PHalChild_h
