//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PHalParent_h
#define PHalParent_h

#include "mozilla/hal_sandbox/PHal.h"
namespace mozilla {
namespace dom {
class PContentParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PBrowserParent;
} // namespace dom
} // namespace mozilla

#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/RPCChannel.h"


namespace mozilla {
namespace dom {
class PContentParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace hal_sandbox {


class /*NS_ABSTRACT_CLASS*/ PHalParent :
    protected mozilla::ipc::RPCChannel::RPCListener,
    protected mozilla::ipc::IProtocolManager<mozilla::ipc::RPCChannel::RPCListener>
{
    friend class mozilla::dom::PContentParent;

protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::hal::BatteryInformation BatteryInformation;
    typedef mozilla::hal::LightConfiguration LightConfiguration;
    typedef mozilla::hal::SensorData SensorData;
    typedef mozilla::hal::NetworkInformation NetworkInformation;
    typedef mozilla::hal::WakeLockInformation WakeLockInformation;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::hal::FlashMode FlashMode;
    typedef mozilla::hal::LightType LightType;
    typedef mozilla::hal::LightMode LightMode;
    typedef mozilla::hal::SensorType SensorType;
    typedef mozilla::hal::WakeLockControl WakeLockControl;
    typedef mozilla::dom::PContentParent PContentParent;
    typedef mozilla::dom::PBrowserParent PBrowserParent;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;

    typedef PHal::State State;

    virtual bool
    RecvVibrate(
            const InfallibleTArray<uint32>& pattern,
            const InfallibleTArray<uint64>& id,
            PBrowserParent* browser) = 0;
    virtual bool
    RecvCancelVibrate(
            const InfallibleTArray<uint64>& id,
            PBrowserParent* browser) = 0;
    virtual bool
    RecvEnableBatteryNotifications() = 0;
    virtual bool
    RecvDisableBatteryNotifications() = 0;
    virtual bool
    RecvGetCurrentBatteryInformation(BatteryInformation* aBatteryInfo) = 0;
    virtual bool
    RecvEnableNetworkNotifications() = 0;
    virtual bool
    RecvDisableNetworkNotifications() = 0;
    virtual bool
    RecvGetCurrentNetworkInformation(NetworkInformation* aNetworkInfo) = 0;
    virtual bool
    RecvGetScreenEnabled(bool* enabled) = 0;
    virtual bool
    RecvSetScreenEnabled(const bool& enabled) = 0;
    virtual bool
    RecvGetScreenBrightness(double* brightness) = 0;
    virtual bool
    RecvSetScreenBrightness(const double& brightness) = 0;
    virtual bool
    RecvAdjustSystemClock(const int32& aDeltaMilliseconds) = 0;
    virtual bool
    RecvSetTimezone(const nsCString& aTimezoneSpec) = 0;
    virtual bool
    RecvSetLight(
            const LightType& light,
            const LightConfiguration& aConfig,
            bool* status) = 0;
    virtual bool
    RecvGetLight(
            const LightType& light,
            LightConfiguration* aConfig,
            bool* status) = 0;
    virtual bool
    RecvReboot() = 0;
    virtual bool
    RecvPowerOff() = 0;
    virtual bool
    RecvModifyWakeLock(
            const nsString& aTopic,
            const WakeLockControl& aLockAdjust,
            const WakeLockControl& aHiddenAdjust) = 0;
    virtual bool
    RecvEnableWakeLockNotifications() = 0;
    virtual bool
    RecvDisableWakeLockNotifications() = 0;
    virtual bool
    RecvGetWakeLockInfo(
            const nsString& aTopic,
            WakeLockInformation* aWakeLockInfo) = 0;
    virtual bool
    RecvEnableSensorNotifications(const SensorType& aSensor) = 0;
    virtual bool
    RecvDisableSensorNotifications(const SensorType& aSensor) = 0;
    virtual bool
    Recv__delete__();

    virtual void
    ActorDestroy(ActorDestroyReason why);

public:
    typedef IPC::Message Message;
    typedef mozilla::ipc::RPCChannel Channel;
    typedef mozilla::ipc::RPCChannel::RPCListener ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::AsyncChannel AsyncChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;

public:
    PHalParent();

    virtual ~PHalParent();

    PContentParent*
    Manager();

    PHal::State
    state();

    bool
    SendNotifyBatteryChange(const BatteryInformation& aBatteryInfo) NS_WARN_UNUSED_RESULT;

    bool
    SendNotifyNetworkChange(const NetworkInformation& aNetworkInfo) NS_WARN_UNUSED_RESULT;

    bool
    SendNotifyWakeLockChange(const WakeLockInformation& aWakeLockInfo) NS_WARN_UNUSED_RESULT;

    bool
    SendNotifySensorChange(const SensorData& aSensorData) NS_WARN_UNUSED_RESULT;

    virtual int32
    Register(ChannelListener* aRouted);
    virtual int32
    RegisterID(
            ChannelListener* aRouted,
            int32 aId);
    virtual ChannelListener*
    Lookup(int32 aId);
    virtual void
    Unregister(int32 aId);
    virtual void
    RemoveManagee(
            int32 aProtocolId,
            ChannelListener* aListener);
    virtual Shmem::SharedMemory*
    CreateSharedMemory(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType type,
            bool unsafe,
            Shmem::id_t* aId);
    virtual bool
    AdoptSharedMemory(
            Shmem::SharedMemory* segment,
            Shmem::id_t* aId);
    virtual Shmem::SharedMemory*
    LookupSharedMemory(Shmem::id_t aId);
    virtual bool
    IsTrackingSharedMemory(Shmem::SharedMemory* segment);
    virtual bool
    DestroySharedMemory(Shmem& aShmem);
    virtual ProcessHandle
    OtherProcess() const;
    virtual AsyncChannel*
    GetIPCChannel();

    virtual Result
    OnMessageReceived(const Message& __msg);

    virtual Result
    OnMessageReceived(
            const Message& __msg,
            Message*& __reply);

    virtual Result
    OnCallReceived(
            const Message& __msg,
            Message*& __reply);

    void
    OnProcessingError(Result code);

    bool
    OnReplyTimeout();

    void
    OnChannelClose();

    void
    OnChannelError();

    void
    OnChannelConnected(int32 pid);

    // Methods for managing shmem
    bool
    AllocShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aMem);

    bool
    AllocUnsafeShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aMem);

    bool
    AdoptShmem(
            Shmem& aMem,
            Shmem* aOutMem);

    bool
    DeallocShmem(Shmem& aMem);

private:
    virtual void
    FatalError(const char* const msg) const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& __v,
            Message* __msg)
    {
        IPC::WriteParam(__msg, __v);
    }

    template<typename T>
    bool
    Read(
            T* __v,
            const Message* __msg,
            void** __iter)
    {
        return IPC::ReadParam(__msg, __iter, __v);
    }

    void
    Write(
            const LightConfiguration& __v,
            Message* __msg);

    bool
    Read(
            LightConfiguration* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            PBrowserParent* __v,
            Message* __msg,
            bool __nullable);

    bool
    Read(
            PBrowserParent** __v,
            const Message* __msg,
            void** __iter,
            bool __nullable) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const BatteryInformation& __v,
            Message* __msg);

    bool
    Read(
            BatteryInformation* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const WakeLockInformation& __v,
            Message* __msg);

    bool
    Read(
            WakeLockInformation* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const NetworkInformation& __v,
            Message* __msg);

    bool
    Read(
            NetworkInformation* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const SensorData& __v,
            Message* __msg);

    bool
    Read(
            SensorData* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            PHalParent* __v,
            Message* __msg,
            bool __nullable);

    bool
    Read(
            PHalParent** __v,
            const Message* __msg,
            void** __iter,
            bool __nullable) NS_WARN_UNUSED_RESULT;

    Channel* mChannel;
    int32 mId;
    mozilla::ipc::IProtocolManager<mozilla::ipc::RPCChannel::RPCListener>* mManager;
    State mState;
};


} // namespace hal_sandbox
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace hal_sandbox {
class HalParent :
    public PHalParent
{
    virtual bool
    RecvVibrate(
            const InfallibleTArray<uint32>& pattern,
            const InfallibleTArray<uint64>& id,
            PBrowserParent* browser);

    virtual bool
    RecvCancelVibrate(
            const InfallibleTArray<uint64>& id,
            PBrowserParent* browser);

    virtual bool
    RecvEnableBatteryNotifications();

    virtual bool
    RecvDisableBatteryNotifications();

    virtual bool
    RecvGetCurrentBatteryInformation(BatteryInformation* aBatteryInfo);

    virtual bool
    RecvEnableNetworkNotifications();

    virtual bool
    RecvDisableNetworkNotifications();

    virtual bool
    RecvGetCurrentNetworkInformation(NetworkInformation* aNetworkInfo);

    virtual bool
    RecvGetScreenEnabled(bool* enabled);

    virtual bool
    RecvSetScreenEnabled(const bool& enabled);

    virtual bool
    RecvGetScreenBrightness(double* brightness);

    virtual bool
    RecvSetScreenBrightness(const double& brightness);

    virtual bool
    RecvAdjustSystemClock(const int32& aDeltaMilliseconds);

    virtual bool
    RecvSetTimezone(const nsCString& aTimezoneSpec);

    virtual bool
    RecvSetLight(
            const LightType& light,
            const LightConfiguration& aConfig,
            bool* status);

    virtual bool
    RecvGetLight(
            const LightType& light,
            LightConfiguration* aConfig,
            bool* status);

    virtual bool
    RecvReboot();

    virtual bool
    RecvPowerOff();

    virtual bool
    RecvModifyWakeLock(
            const nsString& aTopic,
            const WakeLockControl& aLockAdjust,
            const WakeLockControl& aHiddenAdjust);

    virtual bool
    RecvEnableWakeLockNotifications();

    virtual bool
    RecvDisableWakeLockNotifications();

    virtual bool
    RecvGetWakeLockInfo(
            const nsString& aTopic,
            WakeLockInformation* aWakeLockInfo);

    virtual bool
    RecvEnableSensorNotifications(const SensorType& aSensor);

    virtual bool
    RecvDisableSensorNotifications(const SensorType& aSensor);

    HalParent();
    virtual ~HalParent();
};
} // namespace hal_sandbox
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace hal_sandbox {
bool
HalParent::RecvVibrate(
        const InfallibleTArray<uint32>& pattern,
        const InfallibleTArray<uint64>& id,
        PBrowserParent* browser)
{
    return false;
}

bool
HalParent::RecvCancelVibrate(
        const InfallibleTArray<uint64>& id,
        PBrowserParent* browser)
{
    return false;
}

bool
HalParent::RecvEnableBatteryNotifications()
{
    return false;
}

bool
HalParent::RecvDisableBatteryNotifications()
{
    return false;
}

bool
HalParent::RecvGetCurrentBatteryInformation(BatteryInformation* aBatteryInfo)
{
    return false;
}

bool
HalParent::RecvEnableNetworkNotifications()
{
    return false;
}

bool
HalParent::RecvDisableNetworkNotifications()
{
    return false;
}

bool
HalParent::RecvGetCurrentNetworkInformation(NetworkInformation* aNetworkInfo)
{
    return false;
}

bool
HalParent::RecvGetScreenEnabled(bool* enabled)
{
    return false;
}

bool
HalParent::RecvSetScreenEnabled(const bool& enabled)
{
    return false;
}

bool
HalParent::RecvGetScreenBrightness(double* brightness)
{
    return false;
}

bool
HalParent::RecvSetScreenBrightness(const double& brightness)
{
    return false;
}

bool
HalParent::RecvAdjustSystemClock(const int32& aDeltaMilliseconds)
{
    return false;
}

bool
HalParent::RecvSetTimezone(const nsCString& aTimezoneSpec)
{
    return false;
}

bool
HalParent::RecvSetLight(
        const LightType& light,
        const LightConfiguration& aConfig,
        bool* status)
{
    return false;
}

bool
HalParent::RecvGetLight(
        const LightType& light,
        LightConfiguration* aConfig,
        bool* status)
{
    return false;
}

bool
HalParent::RecvReboot()
{
    return false;
}

bool
HalParent::RecvPowerOff()
{
    return false;
}

bool
HalParent::RecvModifyWakeLock(
        const nsString& aTopic,
        const WakeLockControl& aLockAdjust,
        const WakeLockControl& aHiddenAdjust)
{
    return false;
}

bool
HalParent::RecvEnableWakeLockNotifications()
{
    return false;
}

bool
HalParent::RecvDisableWakeLockNotifications()
{
    return false;
}

bool
HalParent::RecvGetWakeLockInfo(
        const nsString& aTopic,
        WakeLockInformation* aWakeLockInfo)
{
    return false;
}

bool
HalParent::RecvEnableSensorNotifications(const SensorType& aSensor)
{
    return false;
}

bool
HalParent::RecvDisableSensorNotifications(const SensorType& aSensor)
{
    return false;
}

HalParent::HalParent()
{
    MOZ_COUNT_CTOR(HalParent);
}

HalParent::~HalParent()
{
    MOZ_COUNT_DTOR(HalParent);
}

} // namespace hal_sandbox
} // namespace mozilla
#endif // if 0

#endif // ifndef PHalParent_h
