//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PFTPChannelParent_h
#define PFTPChannelParent_h

#include "mozilla/net/PFTPChannel.h"
namespace mozilla {
namespace net {
class PNeckoParent;
} // namespace net
} // namespace mozilla

#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/RPCChannel.h"


namespace mozilla {
namespace net {
class PNeckoParent;
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {


class /*NS_ABSTRACT_CLASS*/ PFTPChannelParent :
    protected mozilla::ipc::RPCChannel::RPCListener,
    protected mozilla::ipc::IProtocolManager<mozilla::ipc::RPCChannel::RPCListener>
{
    friend class mozilla::net::PNeckoParent;

protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::Shmem Shmem;
    typedef IPC::URI URI;
    typedef IPC::InputStream InputStream;
    typedef mozilla::net::PNeckoParent PNeckoParent;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;

    typedef PFTPChannel::State State;

    virtual bool
    Recv__delete__();
    virtual bool
    RecvAsyncOpen(
            const URI& uri,
            const PRUint64& startPos,
            const nsCString& entityID,
            const InputStream& uploadStream) = 0;
    virtual bool
    RecvConnectChannel(const PRUint32& channelId) = 0;
    virtual bool
    RecvCancel(const nsresult& status) = 0;
    virtual bool
    RecvSuspend() = 0;
    virtual bool
    RecvResume() = 0;

    virtual void
    ActorDestroy(ActorDestroyReason why);

public:
    typedef IPC::Message Message;
    typedef mozilla::ipc::RPCChannel Channel;
    typedef mozilla::ipc::RPCChannel::RPCListener ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::AsyncChannel AsyncChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;

public:
    PFTPChannelParent();

    virtual ~PFTPChannelParent();

    PNeckoParent*
    Manager();

    PFTPChannel::State
    state();

    bool
    SendOnStartRequest(
            const PRInt32& aContentLength,
            const nsCString& aContentType,
            const PRTime& aLastModified,
            const nsCString& aEntityID,
            const URI& aURI) NS_WARN_UNUSED_RESULT;

    bool
    SendOnDataAvailable(
            const nsCString& data,
            const PRUint32& offset,
            const PRUint32& count) NS_WARN_UNUSED_RESULT;

    bool
    SendOnStopRequest(const nsresult& statusCode) NS_WARN_UNUSED_RESULT;

    bool
    SendFailedAsyncOpen(const nsresult& statusCode) NS_WARN_UNUSED_RESULT;

    bool
    SendDeleteSelf() NS_WARN_UNUSED_RESULT;

    virtual int32
    Register(ChannelListener* aRouted);
    virtual int32
    RegisterID(
            ChannelListener* aRouted,
            int32 aId);
    virtual ChannelListener*
    Lookup(int32 aId);
    virtual void
    Unregister(int32 aId);
    virtual void
    RemoveManagee(
            int32 aProtocolId,
            ChannelListener* aListener);
    virtual Shmem::SharedMemory*
    CreateSharedMemory(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType type,
            bool unsafe,
            Shmem::id_t* aId);
    virtual bool
    AdoptSharedMemory(
            Shmem::SharedMemory* segment,
            Shmem::id_t* aId);
    virtual Shmem::SharedMemory*
    LookupSharedMemory(Shmem::id_t aId);
    virtual bool
    IsTrackingSharedMemory(Shmem::SharedMemory* segment);
    virtual bool
    DestroySharedMemory(Shmem& aShmem);
    virtual ProcessHandle
    OtherProcess() const;
    virtual AsyncChannel*
    GetIPCChannel();

    virtual Result
    OnMessageReceived(const Message& __msg);

    virtual Result
    OnMessageReceived(
            const Message& __msg,
            Message*& __reply);

    virtual Result
    OnCallReceived(
            const Message& __msg,
            Message*& __reply);

    void
    OnProcessingError(Result code);

    bool
    OnReplyTimeout();

    void
    OnChannelClose();

    void
    OnChannelError();

    void
    OnChannelConnected(int32 pid);

    // Methods for managing shmem
    bool
    AllocShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aMem);

    bool
    AllocUnsafeShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aMem);

    bool
    AdoptShmem(
            Shmem& aMem,
            Shmem* aOutMem);

    bool
    DeallocShmem(Shmem& aMem);

private:
    virtual void
    FatalError(const char* const msg) const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& __v,
            Message* __msg)
    {
        IPC::WriteParam(__msg, __v);
    }

    template<typename T>
    bool
    Read(
            T* __v,
            const Message* __msg,
            void** __iter)
    {
        return IPC::ReadParam(__msg, __iter, __v);
    }

    void
    Write(
            PFTPChannelParent* __v,
            Message* __msg,
            bool __nullable);

    bool
    Read(
            PFTPChannelParent** __v,
            const Message* __msg,
            void** __iter,
            bool __nullable) NS_WARN_UNUSED_RESULT;

    Channel* mChannel;
    int32 mId;
    mozilla::ipc::IProtocolManager<mozilla::ipc::RPCChannel::RPCListener>* mManager;
    State mState;
};


} // namespace net
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace net {
class FTPChannelParent :
    public PFTPChannelParent
{
    virtual bool
    RecvAsyncOpen(
            const URI& uri,
            const PRUint64& startPos,
            const nsCString& entityID,
            const InputStream& uploadStream);

    virtual bool
    RecvConnectChannel(const PRUint32& channelId);

    virtual bool
    RecvCancel(const nsresult& status);

    virtual bool
    RecvSuspend();

    virtual bool
    RecvResume();

    FTPChannelParent();
    virtual ~FTPChannelParent();
};
} // namespace net
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace net {
bool
FTPChannelParent::RecvAsyncOpen(
        const URI& uri,
        const PRUint64& startPos,
        const nsCString& entityID,
        const InputStream& uploadStream)
{
    return false;
}

bool
FTPChannelParent::RecvConnectChannel(const PRUint32& channelId)
{
    return false;
}

bool
FTPChannelParent::RecvCancel(const nsresult& status)
{
    return false;
}

bool
FTPChannelParent::RecvSuspend()
{
    return false;
}

bool
FTPChannelParent::RecvResume()
{
    return false;
}

FTPChannelParent::FTPChannelParent()
{
    MOZ_COUNT_CTOR(FTPChannelParent);
}

FTPChannelParent::~FTPChannelParent()
{
    MOZ_COUNT_DTOR(FTPChannelParent);
}

} // namespace net
} // namespace mozilla
#endif // if 0

#endif // ifndef PFTPChannelParent_h
