//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PWebSocketChild_h
#define PWebSocketChild_h

#include "mozilla/net/PWebSocket.h"
namespace mozilla {
namespace net {
class PNeckoChild;
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace dom {
class PBrowserChild;
} // namespace dom
} // namespace mozilla

#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/RPCChannel.h"


namespace mozilla {
namespace net {
class PNeckoChild;
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {


class /*NS_ABSTRACT_CLASS*/ PWebSocketChild :
    protected mozilla::ipc::RPCChannel::RPCListener,
    protected mozilla::ipc::IProtocolManager<mozilla::ipc::RPCChannel::RPCListener>
{
    friend class mozilla::net::PNeckoChild;

protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::Shmem Shmem;
    typedef IPC::URI URI;
    typedef IPC::InputStream InputStream;
    typedef mozilla::net::PNeckoChild PNeckoChild;
    typedef mozilla::dom::PBrowserChild PBrowserChild;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;

    typedef PWebSocket::State State;

    virtual bool
    RecvOnStart(
            const nsCString& aProtocol,
            const nsCString& aExtensions) = 0;
    virtual bool
    RecvOnStop(const nsresult& aStatusCode) = 0;
    virtual bool
    RecvOnMessageAvailable(const nsCString& aMsg) = 0;
    virtual bool
    RecvOnBinaryMessageAvailable(const nsCString& aMsg) = 0;
    virtual bool
    RecvOnAcknowledge(const PRUint32& aSize) = 0;
    virtual bool
    RecvOnServerClose(
            const PRUint16& code,
            const nsCString& aReason) = 0;
    virtual bool
    Recv__delete__();

    virtual void
    ActorDestroy(ActorDestroyReason why);

public:
    typedef IPC::Message Message;
    typedef mozilla::ipc::RPCChannel Channel;
    typedef mozilla::ipc::RPCChannel::RPCListener ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::AsyncChannel AsyncChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;

public:
    PWebSocketChild();

    virtual ~PWebSocketChild();

    PNeckoChild*
    Manager();

    PWebSocket::State
    state();

    bool
    SendAsyncOpen(
            const URI& aURI,
            const nsCString& aOrigin,
            const nsCString& aProtocol,
            const bool& aSecure);

    bool
    SendClose(
            const PRUint16& code,
            const nsCString& reason);

    bool
    SendSendMsg(const nsCString& aMsg);

    bool
    SendSendBinaryMsg(const nsCString& aMsg);

    bool
    SendSendBinaryStream(
            const InputStream& aStream,
            const PRUint32& aLength);

    bool
    SendDeleteSelf();

    virtual int32
    Register(ChannelListener* aRouted);
    virtual int32
    RegisterID(
            ChannelListener* aRouted,
            int32 aId);
    virtual ChannelListener*
    Lookup(int32 aId);
    virtual void
    Unregister(int32 aId);
    virtual void
    RemoveManagee(
            int32 aProtocolId,
            ChannelListener* aListener);
    virtual Shmem::SharedMemory*
    CreateSharedMemory(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType type,
            bool unsafe,
            Shmem::id_t* aId);
    virtual bool
    AdoptSharedMemory(
            Shmem::SharedMemory* segment,
            Shmem::id_t* aId);
    virtual Shmem::SharedMemory*
    LookupSharedMemory(Shmem::id_t aId);
    virtual bool
    IsTrackingSharedMemory(Shmem::SharedMemory* segment);
    virtual bool
    DestroySharedMemory(Shmem& aShmem);
    virtual ProcessHandle
    OtherProcess() const;
    virtual AsyncChannel*
    GetIPCChannel();

    virtual Result
    OnMessageReceived(const Message& __msg);

    virtual Result
    OnMessageReceived(
            const Message& __msg,
            Message*& __reply);

    virtual Result
    OnCallReceived(
            const Message& __msg,
            Message*& __reply);

    void
    OnProcessingError(Result code);

    bool
    OnReplyTimeout();

    void
    OnChannelClose();

    void
    OnChannelError();

    void
    OnChannelConnected(int32 pid);

    // Methods for managing shmem
    bool
    AllocShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aMem);

    bool
    AllocUnsafeShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aMem);

    bool
    AdoptShmem(
            Shmem& aMem,
            Shmem* aOutMem);

    bool
    DeallocShmem(Shmem& aMem);

private:
    virtual void
    FatalError(const char* const msg) const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& __v,
            Message* __msg)
    {
        IPC::WriteParam(__msg, __v);
    }

    template<typename T>
    bool
    Read(
            T* __v,
            const Message* __msg,
            void** __iter)
    {
        return IPC::ReadParam(__msg, __iter, __v);
    }

    void
    Write(
            PWebSocketChild* __v,
            Message* __msg,
            bool __nullable);

    bool
    Read(
            PWebSocketChild** __v,
            const Message* __msg,
            void** __iter,
            bool __nullable) NS_WARN_UNUSED_RESULT;

    Channel* mChannel;
    int32 mId;
    mozilla::ipc::IProtocolManager<mozilla::ipc::RPCChannel::RPCListener>* mManager;
    State mState;
};


} // namespace net
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace net {
class WebSocketChild :
    public PWebSocketChild
{
    virtual bool
    RecvOnStart(
            const nsCString& aProtocol,
            const nsCString& aExtensions);

    virtual bool
    RecvOnStop(const nsresult& aStatusCode);

    virtual bool
    RecvOnMessageAvailable(const nsCString& aMsg);

    virtual bool
    RecvOnBinaryMessageAvailable(const nsCString& aMsg);

    virtual bool
    RecvOnAcknowledge(const PRUint32& aSize);

    virtual bool
    RecvOnServerClose(
            const PRUint16& code,
            const nsCString& aReason);

    WebSocketChild();
    virtual ~WebSocketChild();
};
} // namespace net
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace net {
bool
WebSocketChild::RecvOnStart(
        const nsCString& aProtocol,
        const nsCString& aExtensions)
{
    return false;
}

bool
WebSocketChild::RecvOnStop(const nsresult& aStatusCode)
{
    return false;
}

bool
WebSocketChild::RecvOnMessageAvailable(const nsCString& aMsg)
{
    return false;
}

bool
WebSocketChild::RecvOnBinaryMessageAvailable(const nsCString& aMsg)
{
    return false;
}

bool
WebSocketChild::RecvOnAcknowledge(const PRUint32& aSize)
{
    return false;
}

bool
WebSocketChild::RecvOnServerClose(
        const PRUint16& code,
        const nsCString& aReason)
{
    return false;
}

WebSocketChild::WebSocketChild()
{
    MOZ_COUNT_CTOR(WebSocketChild);
}

WebSocketChild::~WebSocketChild()
{
    MOZ_COUNT_DTOR(WebSocketChild);
}

} // namespace net
} // namespace mozilla
#endif // if 0

#endif // ifndef PWebSocketChild_h
