//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PWebSocketParent_h
#define PWebSocketParent_h

#include "mozilla/net/PWebSocket.h"
namespace mozilla {
namespace net {
class PNeckoParent;
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace dom {
class PBrowserParent;
} // namespace dom
} // namespace mozilla

#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/RPCChannel.h"


namespace mozilla {
namespace net {
class PNeckoParent;
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {


class /*NS_ABSTRACT_CLASS*/ PWebSocketParent :
    protected mozilla::ipc::RPCChannel::RPCListener,
    protected mozilla::ipc::IProtocolManager<mozilla::ipc::RPCChannel::RPCListener>
{
    friend class mozilla::net::PNeckoParent;

protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::Shmem Shmem;
    typedef IPC::URI URI;
    typedef IPC::InputStream InputStream;
    typedef mozilla::net::PNeckoParent PNeckoParent;
    typedef mozilla::dom::PBrowserParent PBrowserParent;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;

    typedef PWebSocket::State State;

    virtual bool
    RecvAsyncOpen(
            const URI& aURI,
            const nsCString& aOrigin,
            const nsCString& aProtocol,
            const bool& aSecure) = 0;
    virtual bool
    RecvClose(
            const PRUint16& code,
            const nsCString& reason) = 0;
    virtual bool
    RecvSendMsg(const nsCString& aMsg) = 0;
    virtual bool
    RecvSendBinaryMsg(const nsCString& aMsg) = 0;
    virtual bool
    RecvSendBinaryStream(
            const InputStream& aStream,
            const PRUint32& aLength) = 0;
    virtual bool
    RecvDeleteSelf() = 0;

    virtual void
    ActorDestroy(ActorDestroyReason why);

public:
    typedef IPC::Message Message;
    typedef mozilla::ipc::RPCChannel Channel;
    typedef mozilla::ipc::RPCChannel::RPCListener ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::AsyncChannel AsyncChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;

public:
    PWebSocketParent();

    virtual ~PWebSocketParent();

    PNeckoParent*
    Manager();

    PWebSocket::State
    state();

    bool
    SendOnStart(
            const nsCString& aProtocol,
            const nsCString& aExtensions) NS_WARN_UNUSED_RESULT;

    bool
    SendOnStop(const nsresult& aStatusCode) NS_WARN_UNUSED_RESULT;

    bool
    SendOnMessageAvailable(const nsCString& aMsg) NS_WARN_UNUSED_RESULT;

    bool
    SendOnBinaryMessageAvailable(const nsCString& aMsg) NS_WARN_UNUSED_RESULT;

    bool
    SendOnAcknowledge(const PRUint32& aSize) NS_WARN_UNUSED_RESULT;

    bool
    SendOnServerClose(
            const PRUint16& code,
            const nsCString& aReason) NS_WARN_UNUSED_RESULT;

    static bool
    Send__delete__(PWebSocketParent* actor) NS_WARN_UNUSED_RESULT;

    virtual int32
    Register(ChannelListener* aRouted);
    virtual int32
    RegisterID(
            ChannelListener* aRouted,
            int32 aId);
    virtual ChannelListener*
    Lookup(int32 aId);
    virtual void
    Unregister(int32 aId);
    virtual void
    RemoveManagee(
            int32 aProtocolId,
            ChannelListener* aListener);
    virtual Shmem::SharedMemory*
    CreateSharedMemory(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType type,
            bool unsafe,
            Shmem::id_t* aId);
    virtual bool
    AdoptSharedMemory(
            Shmem::SharedMemory* segment,
            Shmem::id_t* aId);
    virtual Shmem::SharedMemory*
    LookupSharedMemory(Shmem::id_t aId);
    virtual bool
    IsTrackingSharedMemory(Shmem::SharedMemory* segment);
    virtual bool
    DestroySharedMemory(Shmem& aShmem);
    virtual ProcessHandle
    OtherProcess() const;
    virtual AsyncChannel*
    GetIPCChannel();

    virtual Result
    OnMessageReceived(const Message& __msg);

    virtual Result
    OnMessageReceived(
            const Message& __msg,
            Message*& __reply);

    virtual Result
    OnCallReceived(
            const Message& __msg,
            Message*& __reply);

    void
    OnProcessingError(Result code);

    bool
    OnReplyTimeout();

    void
    OnChannelClose();

    void
    OnChannelError();

    void
    OnChannelConnected(int32 pid);

    // Methods for managing shmem
    bool
    AllocShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aMem);

    bool
    AllocUnsafeShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aMem);

    bool
    AdoptShmem(
            Shmem& aMem,
            Shmem* aOutMem);

    bool
    DeallocShmem(Shmem& aMem);

private:
    virtual void
    FatalError(const char* const msg) const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& __v,
            Message* __msg)
    {
        IPC::WriteParam(__msg, __v);
    }

    template<typename T>
    bool
    Read(
            T* __v,
            const Message* __msg,
            void** __iter)
    {
        return IPC::ReadParam(__msg, __iter, __v);
    }

    void
    Write(
            PWebSocketParent* __v,
            Message* __msg,
            bool __nullable);

    bool
    Read(
            PWebSocketParent** __v,
            const Message* __msg,
            void** __iter,
            bool __nullable) NS_WARN_UNUSED_RESULT;

    Channel* mChannel;
    int32 mId;
    mozilla::ipc::IProtocolManager<mozilla::ipc::RPCChannel::RPCListener>* mManager;
    State mState;
};


} // namespace net
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace net {
class WebSocketParent :
    public PWebSocketParent
{
    virtual bool
    RecvAsyncOpen(
            const URI& aURI,
            const nsCString& aOrigin,
            const nsCString& aProtocol,
            const bool& aSecure);

    virtual bool
    RecvClose(
            const PRUint16& code,
            const nsCString& reason);

    virtual bool
    RecvSendMsg(const nsCString& aMsg);

    virtual bool
    RecvSendBinaryMsg(const nsCString& aMsg);

    virtual bool
    RecvSendBinaryStream(
            const InputStream& aStream,
            const PRUint32& aLength);

    virtual bool
    RecvDeleteSelf();

    WebSocketParent();
    virtual ~WebSocketParent();
};
} // namespace net
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace net {
bool
WebSocketParent::RecvAsyncOpen(
        const URI& aURI,
        const nsCString& aOrigin,
        const nsCString& aProtocol,
        const bool& aSecure)
{
    return false;
}

bool
WebSocketParent::RecvClose(
        const PRUint16& code,
        const nsCString& reason)
{
    return false;
}

bool
WebSocketParent::RecvSendMsg(const nsCString& aMsg)
{
    return false;
}

bool
WebSocketParent::RecvSendBinaryMsg(const nsCString& aMsg)
{
    return false;
}

bool
WebSocketParent::RecvSendBinaryStream(
        const InputStream& aStream,
        const PRUint32& aLength)
{
    return false;
}

bool
WebSocketParent::RecvDeleteSelf()
{
    return false;
}

WebSocketParent::WebSocketParent()
{
    MOZ_COUNT_CTOR(WebSocketParent);
}

WebSocketParent::~WebSocketParent()
{
    MOZ_COUNT_DTOR(WebSocketParent);
}

} // namespace net
} // namespace mozilla
#endif // if 0

#endif // ifndef PWebSocketParent_h
